package com.xperia64.diyedit;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;


	@SuppressWarnings("serial")
	public class GuiDFrame extends JFrame implements ActionListener, ItemListener
	{
	   private JButton ExportToSave;
	   private JButton ExtractFromSave;
	   private JButton DeleteFromSave;
	   private JButton GameMetadata;
	   private JButton RecordMetadata;
	   private JButton PlayExportSong;
	   private JButton MangaMetadata;
	   private JButton ViewManga;
	   private JLabel SaveHeader;
	   private JLabel GameHeader;
	   private JLabel RecordHeader;
	   private JLabel MangaHeader;
	   private JButton OpenFile;
	   private JButton b;
	   private JFrame window;
	   public GuiDFrame()
	   {
	     getContentPane().setLayout(null);
	     setupGUI();
	     setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	   }
	   void setupGUI()
	   {
		Font f = new Font(Font.SANS_SERIF, 3, 10);
		SaveHeader = new JLabel();
		SaveHeader.setLocation(45,20);
		SaveHeader.setSize(150,20);
		SaveHeader.setText("Save Tools");
		getContentPane().add(SaveHeader);
		OpenFile = new JButton();
		OpenFile.setSize(100,20);
		OpenFile.setLocation(0, 0);
		OpenFile.setFont(f);
		OpenFile.setText("Open file...");
		OpenFile.addActionListener(this);
		getContentPane().add(OpenFile);
		ExportToSave = new JButton();
		ExportToSave.setLocation(0,50);
		ExportToSave.setSize(150,20);
		ExportToSave.setText("Add *.mio to save");
		ExportToSave.setFont(f);
		ExportToSave.addActionListener(this);
		ExportToSave.setEnabled(false);
		getContentPane().add(ExportToSave);
		ExtractFromSave = new JButton();
		ExtractFromSave.setLocation(0,80);
		ExtractFromSave.setSize(150,20);
		ExtractFromSave.setText("Extract *.mio from save");
		ExtractFromSave.setFont(f);
		ExtractFromSave.addActionListener(this);
		ExtractFromSave.setEnabled(false);
		getContentPane().add(ExtractFromSave);
		DeleteFromSave = new JButton();
		DeleteFromSave.setLocation(0,110);
		DeleteFromSave.setSize(150,20);
		DeleteFromSave.setText("Delete *.mio from save");
		DeleteFromSave.setFont(f);
		DeleteFromSave.addActionListener(this);
		DeleteFromSave.setEnabled(false);
		getContentPane().add(DeleteFromSave);
		if(Globals.read.length==33554432||Globals.read.length==4719808||Globals.read.length==591040||Globals.read.length==1033408)
		{
			ExportToSave.setEnabled(true);
			ExtractFromSave.setEnabled(true);
			DeleteFromSave.setEnabled(true);
		}
		GameHeader = new JLabel();
		GameHeader.setLocation(200,20);
		GameHeader.setSize(150,20);
		GameHeader.setText("Game Tools");
		getContentPane().add(GameHeader);
		GameMetadata = new JButton();
		GameMetadata.setLocation(160,50);
		GameMetadata.setSize(150,20);
		GameMetadata.setText("Edit game metadata");
		GameMetadata.setFont(f);
		GameMetadata.addActionListener(this);
		if(Globals.read.length!=65536)
		{
			GameMetadata.setEnabled(false);
		}
		getContentPane().add(GameMetadata);
		RecordHeader = new JLabel();
		RecordHeader.setLocation(355,20);
		RecordHeader.setSize(150,20);
		RecordHeader.setText("Record Tools");
		getContentPane().add(RecordHeader);
		RecordMetadata = new JButton();
		RecordMetadata.setLocation(320,50);
		RecordMetadata.setSize(150,20);
		RecordMetadata.setText("Edit Record metadata");
		RecordMetadata.setFont(f);
		RecordMetadata.addActionListener(this);
		RecordMetadata.setEnabled(false);
		getContentPane().add(RecordMetadata);
		PlayExportSong = new JButton();
		PlayExportSong.setLocation(320,80);
		PlayExportSong.setSize(150,20);
		PlayExportSong.setText("Play/Export Midi");
		PlayExportSong.setFont(f);
		PlayExportSong.addActionListener(this);
		PlayExportSong.setEnabled(false);
		getContentPane().add(PlayExportSong);
		if(Globals.read.length==8192)
		{
			RecordMetadata.setEnabled(true);
			PlayExportSong.setEnabled(true);
		}
		MangaHeader = new JLabel();
		MangaHeader.setLocation(510,20);
		MangaHeader.setSize(150,20);
		MangaHeader.setText("Manga/Comic Tools");
		getContentPane().add(MangaHeader);
		MangaMetadata = new JButton();
		MangaMetadata.setLocation(480,50);
		MangaMetadata.setSize(150,20);
		MangaMetadata.setText("Edit Manga metadata");
		MangaMetadata.setFont(f);
		MangaMetadata.addActionListener(this);
		MangaMetadata.setEnabled(false);
		getContentPane().add(MangaMetadata);
		ViewManga = new JButton();
		ViewManga.setLocation(480,80);
		ViewManga.setSize(150,20);
		ViewManga.setText("View Manga/Comic");
		ViewManga.setFont(f);
		ViewManga.addActionListener(this);
		ViewManga.setEnabled(false);
		getContentPane().add(ViewManga);
		if(Globals.read.length==14336)
		{
			MangaMetadata.setEnabled(true);
			ViewManga.setEnabled(true);
		}
		setLocation(50,50);
		setTitle("untitled");
		setSize(650,200);
		setVisible(true);
		setResizable(false);
		
	   }
	   public void actionPerformed(ActionEvent e) {
		   
	        if (e.getSource() == GameMetadata&&!Globals.MetadataShown) {
	        	Globals.MetadataShown=true;
	        	Globals.MetadataMode=0;
	        	new MetadataFrame();
	        } else if (e.getSource() == RecordMetadata&&!Globals.MetadataShown) {
	        	Globals.MetadataShown=true;
	        	Globals.MetadataMode=1;
	            new MetadataFrame();
	        }else if (e.getSource() == MangaMetadata&&!Globals.MetadataShown)
	        {
	        	Globals.MetadataShown=true;
	        	Globals.MetadataMode=2;
	        	new MetadataFrame();
	        }else if(e.getSource() == PlayExportSong&&!Globals.playing){
	        	new MusicPlayer();
	        	
	        }else if(e.getSource()==ViewManga){
	        drawManga();
	        }else if(e.getSource()==b)
	        {
	        	window.setVisible(false);
	        }else if(e.getSource()==OpenFile)
	        {
	        	this.setVisible(false);
	        	new FileChooser();
	        }else if(e.getSource()==ExportToSave)
	        {
	        	
	        	if(Globals.read.length==33554432){
	        		JFileChooser fc = new JFileChooser();
        			fc.setFileFilter(new MioFilter());
        			if(fc.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
        			{
		        	String mi = JOptionPane.showInputDialog("Pick item number (1-90): ");
		        	if(isInteger(mi))
		        	{
		        		if(Integer.parseInt(mi)>=1&&Integer.parseInt(mi)<=90)
		        		{
		        		Globals.MyfileIO.write(new SaveHandler().setMio(Globals.name,fc.getSelectedFile().getAbsolutePath(), Integer.parseInt(mi)-1),Globals.name);
		        		JOptionPane.showMessageDialog(this, "Mio added to save successfully!");
		        		}else{
		        			JOptionPane.showMessageDialog(this, "Invalid item number!");
		        		}
		        	}else{
		        		JOptionPane.showMessageDialog(this, "Not a number!");
		        	}
        			}
		        	}else{
		        		
		        	}
	        }else if(e.getSource()==ExtractFromSave)
	        {if(Globals.read.length==33554432){
	        	Object[] options = {"Microgames",
	                    "Records",
	                    "Comics/Manga"};
	        		int n = JOptionPane.showOptionDialog(this, "Choose Mode:  ", "Untitled",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,null,options,options[2]);
	        	String mi = JOptionPane.showInputDialog("Pick item number (1-90): ");
	        	if(isInteger(mi))
	        	{
	        		if(Integer.parseInt(mi)>=1&&Integer.parseInt(mi)<=90)
	        		{
	        			JFileChooser fc = new JFileChooser();
	        			fc.setFileFilter(new MioFilter());
	        			if(fc.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
	        			{
	        				Globals.MyfileIO.write(new SaveHandler().getMio(Globals.name, n, Integer.parseInt(mi)-1),fc.getSelectedFile().getAbsolutePath());
	        				JOptionPane.showMessageDialog(this, "Mio exported successfully!");
	        			}
	        		}else{
	        			JOptionPane.showMessageDialog(this, "Invalid item number!");
	        		}
	        	}else{
	        		JOptionPane.showMessageDialog(this, "Not a number!");
	        	}
	        	
	        	}else{
	        		
	        	}
	        }else if(e.getSource()==DeleteFromSave)
	        {
	        	if(Globals.read.length==33554432){
	        	Object[] options = {"Microgames",
	                    "Records",
	                    "Comics/Manga"};
	        		int n = JOptionPane.showOptionDialog(this, "Choose Mode:  ", "Untitled",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,null,options,options[2]);
	        	String mi = JOptionPane.showInputDialog("Pick item number (1-90): ");
	        	if(isInteger(mi))
	        	{
	        		if(Integer.parseInt(mi)>=1&&Integer.parseInt(mi)<=90)
	        		{
	        			Globals.MyfileIO.write(new SaveHandler().deleteMio(Globals.name,n, Integer.parseInt(mi)-1),Globals.name);
	        			JOptionPane.showMessageDialog(this, "Mio deleted from save successfully!");
	        		}else{
	        			JOptionPane.showMessageDialog(this, "Invalid item number!");
	        		}
	        		
	        	}else{
	        		JOptionPane.showMessageDialog(this, "Not a number!");
	        	}
	        	
	        	}else{
	        		
	        	}
	        }else{
	        	System.out.println("Hax");
	        }
	   }
	    
	 
	    public void itemStateChanged(ItemEvent e)  {
	 
	        @SuppressWarnings("unused")
			Object source = e.getItemSelectable();

	    }
	    private void drawManga()
	    {
	    	b = new JButton();
	    	b.setLocation(0,200);
	    	b.setSize(50,10);
	    	b.setText("Back");
	    	b.addActionListener(this);
	    	MangaPreviewer t = new MangaPreviewer(0);
	    	MangaPreviewer t1 = new MangaPreviewer(1);
	    	MangaPreviewer t2 = new MangaPreviewer(2);
	    	MangaPreviewer t3 = new MangaPreviewer(3);
	    	window = new JFrame();
			 window.setLayout(new GridLayout(1,3));
			    window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			    window.setBounds(30, 30, 1000, 1000);
			    Container container = window.getContentPane();
		        ArrayList < JComponent > components = new ArrayList < JComponent >();
		        components.add( t );
		        container.add(t);
		        components.add( t1 );
	            container.add(t1);
	            components.add( t2 );
	            container.add(t2);
	            components.add( t3 );
	            container.add(t3);
		        window.pack();
		        window.add(b);
		        window.setTitle(new MangaMetadata().getName());
		        window.setSize(1050,158);
		        window.setResizable(false);
			    window.setVisible(true);
	    }
	    public static boolean isInteger(String s) {
		    try { 
		        Integer.parseInt(s); 
		    } catch(NumberFormatException e) { 
		        return false; 
		    }
		    // only got here if we didn't return false
		    return true;
		}
	}
	@SuppressWarnings("serial")
	class MangaPreviewer extends JComponent
	{
		int i;
		public MangaPreviewer(int p)
		{
			i=p;
		}
		//192x128
		public void paint(Graphics g) {


				int x=0;
				int y=0;
				boolean done=false;
				while(!done)
				{
					MangaEdit e2 = new MangaEdit();
					if(e2.getPixel((byte) i, x, y))
					{
						g.setColor(new Color(0,0,0));
					}else{
						g.setColor(new Color(255,255,255));
					}
					g.drawRect(x,y,1,1);
					
					x++;
					if(x>191)
					{
						y+=1;
						x=0;	
					}
					if(x>191&&y>127||y>127)
					{
						done=true;
					
				}
					}
					
			
			
			
				
		  }
		
	}
	
