package com.xperia64.diyedit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class MetadataFrame extends JFrame implements ActionListener, ItemListener {

	// Common:
	private JButton Back;
	private JTextField Name;
	private JLabel NameHeader;
	private JTextField Description;
	private JLabel DescriptionHeader;
	private JTextField Brand;
	private JLabel BrandHeader;
	private JTextField Creator;
	private JLabel CreatorHeader;
	private JLabel SerialHeader;
	private JTextField Serial1;
	private JLabel Dash1;
	private JTextField Serial2;
	private JLabel Dash2;
	private JTextField Serial3;
	private JCheckBox Lock;
	private JComboBox<String> ItemColor;
	private JLabel ItemColorHeader;
	private JComboBox<String> Logo;
	private JLabel LogoHeader;
	private JComboBox<String> LogoColor;
	private JLabel LogoColorHeader;
	private JButton Apply;
	// Game Specific:
	private JTextField Command;
	private JLabel CommandHeader;
	private JComboBox<String> GameLength;
	private JLabel LengthHeader;
	private JComboBox<String> CartType;
	private JLabel CartHeader;
	private JButton DrawPreview;
	// Record Specific:
	private JComboBox<String> RecordType;
	private JLabel RecordHeader;
	// Manga Specific:
	// None
	public MetadataFrame()
	{
	    getContentPane().setLayout(null);
	    setupGUI();
	    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	void setupGUI()
	{
		// Common
		String Names="";
		String Descriptions="";
		String Brands="";
		String Creators="";
		String Serial1s="";
		String Serial2s="";
		String Serial3s="";
		boolean Locked=false;
		int ItemColors=0;
		int Logos=0;
		int LogoColors=0;
		// Game Specific:
		String Commands="";
		int Lengths=0;
		int CartridgeType=0;
		// Record Specific:
		int RecordTypes=0;
		// Manga Specific:
		// None
		switch(Globals.MetadataMode)
		{
		case 0:
			GameMetadata g = new GameMetadata();
			Names=g.getName();
			Descriptions=g.getDescription();
			Brands=g.getBrand();
			Creators = g.getCreator();
			Serial1s = g.getSerial1();
			Serial2s = Integer.toString(g.getSerial2());
			Serial3s = Integer.toString(g.getSerial3());
			Locked=g.getLocked();
			ItemColors=g.getCartColor();
			Logos=g.getLogo();
			LogoColors=g.getLogoColor();
			Commands = g.getCommand();
			CartridgeType=g.getCartType();
			Lengths=g.getLength();
			break;
		case 1:
			RecordMetadata r = new RecordMetadata();
			Names=r.getName();
			Descriptions=r.getDescription();
			Brands=r.getBrand();
			Creators = r.getCreator();
			Serial1s = r.getSerial1();
			Serial2s = Integer.toString(r.getSerial2());
			Serial3s = Integer.toString(r.getSerial3());
			Locked=r.getLocked();
			ItemColors=r.getRecordColor();
			Logos=r.getLogo();
			LogoColors=r.getLogoColor();
			RecordTypes = r.getRecordType();
			break;
		case 2:
			MangaMetadata m = new MangaMetadata();
			Names=m.getName();
			Descriptions=m.getDescription();
			Brands=m.getBrand();
			Creators = m.getCreator();
			Serial1s = m.getSerial1();
			Serial2s = Integer.toString(m.getSerial2());
			Serial3s = Integer.toString(m.getSerial3());
			Locked=m.getLocked();
			ItemColors=m.getMangaColor();
			Logos=m.getLogo();
			LogoColors=m.getLogoColor();
			break;
		default:
			return;
		}
		Back = new JButton();
		Back.setSize(200,50);
		Back.setLocation(600,120);
		Back.setText("Back");
		Back.addActionListener(this);
		getContentPane().add(Back);
		NameHeader = new JLabel();
		NameHeader.setSize(130,20);
		NameHeader.setLocation(0,0);
		NameHeader.setText(getMode()+"Name:");
		getContentPane().add(NameHeader);
		Name = new JTextField();
		Name.setSize(76,25);
		Name.setLocation(10,20);
		Name.setText(Names);
		getContentPane().add(Name);
		DescriptionHeader = new JLabel();
		DescriptionHeader.setSize(150,20);
		DescriptionHeader.setLocation(140,0);
		DescriptionHeader.setText(getMode()+"Description:");
		getContentPane().add(DescriptionHeader);
		Description = new JTextField();
		Description.setSize(220,25);
		Description.setLocation(100,20);
		Description.setText(Descriptions);
		getContentPane().add(Description);
		BrandHeader = new JLabel();
		BrandHeader.setSize(140,20);
		BrandHeader.setLocation(350,0);
		BrandHeader.setText("Brand: ");
		getContentPane().add(BrandHeader);
		Brand = new JTextField();
		Brand.setSize(75,25);
		Brand.setLocation(350,20);
		Brand.setText(Brands);
		getContentPane().add(Brand);
		CreatorHeader = new JLabel();
		CreatorHeader.setSize(100,20);
		CreatorHeader.setLocation(450,0);
		CreatorHeader.setText("Creator:");
		getContentPane().add(CreatorHeader);
		Creator = new JTextField();
		Creator.setSize(75,25);
		Creator.setLocation(450,20);
		Creator.setText(Creators);
		getContentPane().add(Creator);
		SerialHeader = new JLabel();
		SerialHeader.setSize(100,20);
		SerialHeader.setLocation(550,0);
		SerialHeader.setText("Serial Number:");
		getContentPane().add(SerialHeader);
		Serial1 = new JTextField();
		Serial1.setSize(40,25);
		Serial1.setLocation(550,20);
		Serial1.setText(Serial1s);
		getContentPane().add(Serial1);
		Dash1 = new JLabel();
		Dash1.setSize(10,20);
		Dash1.setLocation(590,20);
		Dash1.setText("-");
		getContentPane().add(Dash1);
		Serial2 = new JTextField();
		Serial2.setSize(40,25);
		Serial2.setLocation(595,20);
		Serial2.setText(Serial2s);
		getContentPane().add(Serial2);
		Dash2 = new JLabel();
		Dash2.setSize(10,20);
		Dash2.setLocation(635,20);
		Dash2.setText("-");
		getContentPane().add(Dash2);
		Serial3 = new JTextField();
		Serial3.setSize(30,25);
		Serial3.setLocation(640,20);
		Serial3.setText(Serial3s);
		getContentPane().add(Serial3);
		Lock = new JCheckBox();
		Lock.setSize(100,20);
		Lock.setText("Locked");
		Lock.setLocation(670,20);
		Lock.setSelected(Locked);
		getContentPane().add(Lock);
		ItemColorHeader = new JLabel();
		ItemColorHeader.setSize(150,20);
		ItemColorHeader.setLocation(0,100);
		ItemColorHeader.setText(getMode()+"Color:");
		getContentPane().add(ItemColorHeader);
		ItemColor = new JComboBox<String>();
		ItemColor.addItem("Yellow");
		ItemColor.addItem("Light Blue");
		ItemColor.addItem("Green");
		ItemColor.addItem("Orange");
		ItemColor.addItem("Dark Blue");
		ItemColor.addItem("Red");
		ItemColor.addItem("White");
		ItemColor.addItem("Black");
		ItemColor.setSize(100,25);
		ItemColor.setLocation(10,120);
		ItemColor.setSelectedIndex(ItemColors);
		getContentPane().add(ItemColor);
		LogoHeader = new JLabel();
		LogoHeader.setSize(100,20);
		LogoHeader.setLocation(120,100);
		LogoHeader.setText(getMode()+"Logo:");
		getContentPane().add(LogoHeader);
		Logo = new JComboBox<String>();
		for(int i = 0; i<8; i++)
		{
			Logo.addItem(getLogo(i));
		}
		Logo.setSize(150,25);
		Logo.setLocation(120,120);
		Logo.setSelectedIndex(Logos);
		getContentPane().add(Logo);
		LogoColorHeader = new JLabel();
		LogoColorHeader.setSize(100,20);
		LogoColorHeader.setLocation(290,100);
		LogoColorHeader.setText("Logo Color:");
		getContentPane().add(LogoColorHeader);
		LogoColor = new JComboBox<String>();
		LogoColor.addItem("Yellow");
		LogoColor.addItem("Light Blue");
		LogoColor.addItem("Green");
		LogoColor.addItem("Orange");
		LogoColor.addItem("Dark Blue");
		LogoColor.addItem("Red");
		LogoColor.addItem("White");
		LogoColor.addItem("Black");
		LogoColor.setSize(100,25);
		LogoColor.setSelectedIndex(LogoColors);
		LogoColor.setLocation(290,120);
		getContentPane().add(LogoColor);
		Apply = new JButton();
		Apply.setSize(200,50);
		Apply.setLocation(400,120);
		Apply.setText("Apply Changes");
		Apply.addActionListener(this);
		getContentPane().add(Apply);
		switch(Globals.MetadataMode)
		{
		case 0:
			CommandHeader = new JLabel();
			CommandHeader.setSize(100,20);
			CommandHeader.setLocation(0,50);
			CommandHeader.setText("Command: ");
			getContentPane().add(CommandHeader);
			Command = new JTextField();
			Command.setSize(200,25);
			Command.setLocation(10,70);
			Command.setText(Commands);
			getContentPane().add(Command);
			LengthHeader = new JLabel();
			LengthHeader.setLocation(220,50);
			LengthHeader.setSize(100,20);
			LengthHeader.setText("Game Length:");
			getContentPane().add(LengthHeader);
			GameLength=new JComboBox<String>();
			GameLength.addItem("Short");
			GameLength.addItem("Long");
			GameLength.addItem("Boss");
			GameLength.setSelectedIndex(Lengths);
			GameLength.setSize(100,25);
			GameLength.setLocation(220,70);
			getContentPane().add(GameLength);
			CartHeader = new JLabel();
			CartHeader.setLocation(350,50);
			CartHeader.setSize(100,20);
			CartHeader.setText("Cartridge Shape: ");
			getContentPane().add(CartHeader);
			CartType = new JComboBox<String>();
			CartType.setSize(200,25);
			CartType.setLocation(350,70);
			CartType.addItem("Rounded Top");
			CartType.addItem("Hole in Top");
			CartType.addItem("Flat Top with Ridges");
			CartType.addItem("Round Top with Ridged Bottom");
			CartType.addItem("Flat Top with Zigzags");
			CartType.addItem("Top with two Notches");
			CartType.addItem("Angled Top");
			CartType.addItem("GBA Style");
			CartType.addItem("Star");
			CartType.setSelectedIndex(CartridgeType);
			getContentPane().add(CartType);
			DrawPreview = new JButton();
			DrawPreview.setSize(200,45);
			DrawPreview.setLocation(570,50);
			DrawPreview.setText("Show Game Preview");
			DrawPreview.addActionListener(this);
			getContentPane().add(DrawPreview);
			break;
		case 1:
			RecordHeader = new JLabel();
			RecordHeader.setLocation(350,50);
			RecordHeader.setSize(100,20);
			RecordHeader.setText("Record Shape: ");
			getContentPane().add(RecordHeader);
			RecordType = new JComboBox<String>();
			RecordType.setSize(200,25);
			RecordType.setLocation(350,70);
			RecordType.addItem("Circle");
			RecordType.addItem("Square");
			RecordType.addItem("Star");
			RecordType.addItem("Hexagon");
			RecordType.addItem("Clover");
			RecordType.addItem("Diamond");
			RecordType.addItem("Fat Cross");
			RecordType.addItem("Flower");
			RecordType.setSelectedIndex(RecordTypes);
			getContentPane().add(RecordType);
			break;
			
		}
		setLocation(100,100);
		setTitle("Metadata Editor");
		setSize(830,200);
		setVisible(true);
		setResizable(false);
	}
	private String getMode()
	{
		switch(Globals.MetadataMode)
		{
		case 0:
			return "Game ";
		case 1:
			return "Record ";
		case 2:
			return "Comic/Manga ";
		default:
			return "Huh?";
		}
	}
	private String getLogo(int i)
	{
		switch(Globals.MetadataMode)
		{
		case 0:
			switch(i)
			{
			case 0:
				return "Pulse";
			case 1:
				return "Rocket";
			case 2:
				return "Sword";
			case 3:
				return "Fist";
			case 4:
				return "Car";
			case 5:
				return "Bat";
			case 6:
				return "Blocks";
			case 7:
				return "Blob";
			}
			break;
		case 1:
			switch(i)
			{
			case 0:
				return "Heart";
			case 1:
				return "Flower";
			case 2:
				return "Hurricane";
			case 3:
				return "X";
			case 4:
				return "Leaf";
			case 5:
				return "Droplet";
			case 6:
				return "Lightning";
			case 7:
				return "Smile";
			}
			break;
		case 2:
			switch(i)
			{
			case 0:
				return "Heart";
			case 1:
				return "House";
			case 2:
				return "Sword";
			case 3:
				return "Skull";
			case 4:
				return "Cat";
			case 5:
				return "Bat";
			case 6:
				return "Alien";
			case 7:
				return "Smile";
			}
		}
		return "";
	}
	public void actionPerformed(ActionEvent e) {  
		if(e.getSource()==DrawPreview)
		   {
			new PreviewRenderer().drawpreview();   
		   }
		if(e.getSource()==Apply)
		{
			applyChanges();
		}
		if(e.getSource()==Back)
		{
			Globals.MetadataShown=false;
			this.setVisible(false);
		}
	}
    
 
    public void itemStateChanged(ItemEvent e)  {
 
        @SuppressWarnings("unused")
		Object source = e.getItemSelectable();
    }
    private void applyChanges()
    {
    	Metadata m = new Metadata();
    	if(Name.getText().length()>12)
    	{
    		JOptionPane.showMessageDialog(this, "Name cannot be longer than 12 characters!");
    		return;
    	}
    	m.setName(Name.getText());
    	if(Description.getText().length()>36)
    	{
    		JOptionPane.showMessageDialog(this, "Description cannot be longer than 36 characters!");
    		return;
    	}
    	m.setDescription(Description.getText());
    	if(Brand.getText().length()>9)
    	{
    		JOptionPane.showMessageDialog(this, "Brand name cannot be named longer than 9 characters!");
    		return;
    	}
    	m.setBrand(Brand.getText());
    	if(Creator.getText().length()>9)
    	{
    		JOptionPane.showMessageDialog(this, "Creator name cannot be longer than 9 characters!");
    		return;
    	}
    	m.setCreator(Creator.getText());
    	if(Serial1.getText().length()>4)
    	{
    		JOptionPane.showMessageDialog(this, "First serial cannot be more than 4 characters!");
    		return;
    	}
    	if(Serial2.getText().length()>4||!isInteger(Serial2.getText()))
    	{
    		JOptionPane.showMessageDialog(this, "Second serial cannot be more than 4 characters and must be numeric!");
    		return;
    	}
    	if(Serial3.getText().length()>3||!isInteger(Serial3.getText()))
    	{
    		JOptionPane.showMessageDialog(this, "Third serial cannot be more than 3 characters and must be numeric!");
    		return;
    	}
    	m.setSerial(Serial1.getText(), Integer.parseInt(Serial2.getText()), Integer.parseInt(Serial3.getText()));
    	m.setLocked(Lock.isSelected());
    	switch(Globals.MetadataMode)
    	{
    	case 0:
    		
    		new GameMetadata().setCartType((byte) CartType.getSelectedIndex());
    		new GameMetadata().setCartColor((byte)ItemColor.getSelectedIndex());
    		new GameMetadata().setLogo((byte)Logo.getSelectedIndex());
    		new GameMetadata().setLogoColor((byte)LogoColor.getSelectedIndex());
    		new GameMetadata().setLength((byte)GameLength.getSelectedIndex());
    		if(Command.getText().length()>12)
    		{
    			JOptionPane.showMessageDialog(this, "Command cannot be longer than 12 characters!");
        		return;
    		}
    		new GameMetadata().setCommand(Command.getText());
    		break;
    	case 1:
    		new RecordMetadata().setRecordType((byte) RecordType.getSelectedIndex());
    		new RecordMetadata().setRecordColor((byte)ItemColor.getSelectedIndex());
    		new RecordMetadata().setLogo((byte)Logo.getSelectedIndex());
    		new RecordMetadata().setLogoColor((byte)LogoColor.getSelectedIndex());
    		break;
    	case 2:
    		new MangaMetadata().setMangaColor((byte)ItemColor.getSelectedIndex());
    		new MangaMetadata().setLogo((byte)Logo.getSelectedIndex());
    		new MangaMetadata().setLogoColor((byte)LogoColor.getSelectedIndex());
    		break;
    	}
    	new Checksums().writeChecksums(true);
    }
    public static boolean isInteger(String s) {
        try { 
            Integer.parseInt(s); 
        } catch(NumberFormatException e) { 
            return false; 
        }
        // only got here if we didn't return false
        return true;
    }
}
