package com.xperia64.diyedit;

// Class for editing records
public class RecordEdit extends RecordMetadata{
	// Up to 24 blocks of 32 notes, 5 tracks 0-4
	public byte getVolume(int block, int track)
	{
		/**@param block: 0-24*/
		//track=0-4;
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(256+track);
		return Globals.read[offset];
		
	}
	// Up to 24 blocks of 32 notes, 5 tracks 0-4, volume 0-4
	public void setVolume(int block, int track, byte volume)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(256+track);
		Globals.read[offset]=volume;
	}
	// Up to 24 blocks of 32 notes, 5 tracks 0-4
	public byte getPanning(int block, int track)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(261+track);
		return Globals.read[offset];
	}
	// Up to 24 blocks of 32 notes, 5 tracks 0-4, panning 0-4
	public void setPanning(int block, int track, byte panning)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(261+track);
		Globals.read[offset]=panning;
	}
	// Up to 24 blocks of 32 notes, 4 tracks 0-3
	public byte getInstrument(int block, int track)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(266+track);
		return Globals.read[offset];
	}
	// Up to 24 blocks of 32 notes, 4 tracks 0-3, 48 instruments 0-2F
	public void setInstrument(int block, int track, byte instrument)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(266+track);
		Globals.read[offset]=instrument;
	}
	// Up to 24 blocks of 32 notes
	public byte getDrumset(int block)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(266+4);
		return Globals.read[offset];
	}
	// Up to 24 blocks of 32 notes, 8 drumsets 0-7
	public void setDrumset(int block, byte drumset)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=(266+4);
		Globals.read[offset]=drumset;
	}
	// Up to 24 blocks of 32 notes, 4 tracks 0-3, 32 notes 0-1F
	@SuppressWarnings("unused")
	public int getNote(int block, int track, int position)
	{
		int offset;
		int noteo=0;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		for(int i=noteo;noteo<track*32;noteo+=32);
		offset+=position+noteo;
		return Globals.read[offset];
	}
	// Up to 24 blocks of 32 notes, 4 tracks 0-3, 32 notes 0-1F, 25 pitches 0-18
	@SuppressWarnings("unused")
	public void setNote(int block, int track, int position, byte note)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		for(int i=offset;offset<track*32;offset+=32);
		offset+=position;
		Globals.read[offset]=note;
	}
	// Up to 24 blocks of 32 notes, Up to 4 drums 0-3, 32 notes 0-1F
	@SuppressWarnings("unused")
	public byte getDrum(int block, int drumNumber, int position)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=128;
		for(int i=offset;offset<drumNumber*32;offset+=32);
		offset+=position;
		return Globals.read[offset];
	}
	// Up to 24 blocks of 32 notes, Up to 4 drums 0-3, 32 notes 0-1F, 14 drums 0-D
	@SuppressWarnings("unused")
	public void setDrum(int block, int drumNumber, int position, byte drum)
	{
		int offset;
		//get block
		for(offset=263; offset<block*276; offset+=276);
		offset+=128;
		for(int i=offset;offset<drumNumber*32;offset+=32);
		offset+=position;
		Globals.read[offset]=drum;
	}
	// Finds note number from given string (e.g. "Low-Sol")
	public byte findNote(String n)
	{
		for(int i = 0; i<Globals.noteCodes.length; i++)
		{
			if(n==Globals.noteCodes[i])
			{
				return (byte)i;
			}
		}
		return (byte) 0;
	}
	// Finds note number from given string, real note names (e.g. "Low-G")
	public byte findPianoNote(String n)
	{
		for(int i = 0; i<Globals.noteCodesPiano.length; i++)
		{
			if(n==Globals.noteCodesPiano[i])
			{
				return (byte)i;
			}
		}
		return (byte) 0;
	}
	
	
	
}
