package com.xperia64.diyedit;

// Handles save file operations for DS and RAW Wii saves
public class SaveHandler {

	private byte[] read1; // Savefile
	private byte[] read2; // Miofile
	public byte[] getMio(String filename, int dsmode, int mionumber) // Filename is the save file name
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		if(read1.length==4719808||read1.length==591040||read1.length==1033408)
		{
			WiiSave w = new WiiSave(read1, new byte[0], mionumber); // mionumber=0-77
			return w.getMio();
		}else if(read1.length==33554432)
		{
			DSSave d = new DSSave(read1, new byte[0], dsmode, mionumber); // dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			return d.getMio();
		}else{
			return new byte[0];
		}
	}
	public byte[] setMio(String filename, String mioname, int mionumber) // Filename is the save file name, mioname is the mio filename
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		read2=fbo.read(mioname);
		if(read2.length!=65536&&read2.length!=8192&&read2.length!=14336)
		{
			System.out.println("Not a mio file!");
			return new byte[0];
		}
		if(read1.length==33554432) // It's a ds save!
		{
			int mode=0;
			switch(read2.length)
			{
			case 8192:
				mode=1;
				break;
			case 14366:
				mode=2;
				break;
			case 65536:
				mode=0;
				break;
			}
			DSSave d = new DSSave(read1, read2, mode, mionumber);
			return d.setMio();
		}else if(read1.length==4719808||read1.length==591040||read1.length==1033408){ // It's a wii save!
			WiiSave w = new WiiSave(read1, read2, mionumber);
			return w.setMio();
		}else{ 
			return read1;
		}
	}
	public byte[] deleteMio(String filename,int dsmode, int mionumber)
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		if(read1.length==4719808||read1.length==591040||read1.length==1033408)
		{
			WiiSave w = new WiiSave(read1, new byte[0], mionumber); // mionumber=0-77
			return w.deleteMio();
		}else if(read1.length==33554432)
		{
			DSSave d = new DSSave(read1, new byte[0], dsmode, mionumber); // dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			return d.deleteMio();
		}else{
			return new byte[0];
		}
	}
	public byte[] unlockMedals(String filename)
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		return new DSSave(read1, new byte[0], 0, 0).unlockMedals();
	}
	public byte[] unlockGames(String filename)
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		return new DSSave(read1, new byte[0], 0, 0).unlockGames();
	}
	public byte[] unlockRecords(String filename)
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		return new DSSave(read1, new byte[0], 0, 0).unlockRecords();
	}
	public byte[] unlockManga(String filename)
	{
		FileByteOperations fbo = new FileByteOperations();
		read1=fbo.read(filename);
		return new DSSave(read1, new byte[0], 0, 0).unlockManga();
	}
}
